unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    btnCheck: TButton;
    procedure btnCheckClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses winsock;

{$R *.dfm}

procedure TForm1.btnCheckClick(Sender: TObject);
procedure PortScan(AIP: string; APort: integer);
  var
    data: TWSAData;
    sock: TSocket;
    addr: TSockAddrIn;
    iaddr: TInAddr;
  begin
    try
      if (WSAStartup($0101, data) = 0) then
      begin
        sock := socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
        if (sock <> INVALID_SOCKET) then
        begin
          // zero out the addr struct.
          FillChar(addr, SizeOf(TSockAddrIn), 0);
          FillChar(iaddr, SizeOf(TInAddr), 0);

          //fill in the internet address
          iaddr.S_addr := inet_addr(PChar(AIP));

          //fill in the rest of the address.
          addr.sin_family := PF_INET;
          addr.sin_port := htons(APort);
          addr.sin_addr := iaddr;

          // try to connect, if it failes then the port is closed
          if (connect(sock, addr, SizeOf(TSockAddrIn)) = 0) then
          begin
            ShowMessage('Port ' + IntToStr(APort) + ' IS open on ' + AIP);
          end else
          begin
            ShowMessage('Port NOT open ' + IntToStr(APort) + ' on ' + AIP);
          end;
        end else
        begin
          ShowMessage('There was an error creating the socket.');
        end;
      end else
      begin
        ShowMessage('Failed to initialize winsock.');
      end;
    finally
      WSACleanup();
    end;
  end;
begin
  btnCheck.Enabled := False;
  PortScan(Edit1.Text, StrToInt(Edit2.Text));
  btnCheck.Enabled := True;
end;

end.
